{$D+}
{$N+}
{$I-}

      (*   For Baseline-coded JPEGs ONLY !   *)
      (* (C) 2000 Alex  E-mail: tm@osu.ac.ru *)

  Var FileName:string;                                 { File Name string }
      PictureFile:file;                              { Work file variable }
      FilePtr:word;                                 { Counter block bytes }
      Width,Height:word;                                     { Image Size }
      planes:longint;                               { Color Planes Number }
      method:byte;                                   { Compression method }
      Marker:array [$C0..$FE] of boolean;                { Marker present }
      Current_bit,                           { Current bit & Current byte }
      Current_byte:byte;
      ComponentID:array [1..4] of record C,H,V,T:byte end; { Component ID }
                             { (No, Sampling factors, Quantization Table) }
      Huff_Tab:record L:array [1..16] of byte;           { Huffman Tables }
                      V:array [1..16,1..255] of byte;
                      C:array [0..1,0..3,0..$FF] of record L:byte; V:word end end;
      ZigZag:array [0..3,0..63] of word;            { Quantization Tables }
      Scan:record Component,TD,TA:array [1..4] of byte;      { Scan Header}
                                  Ss,Se,Ah,Al:byte end;  { (Tables, etc.) }
      ACT:array [0..1,0..3] of byte;        { Arithmetic Table (not used) }
      RestartInterval:word;                            { Restart Interval }
      sum,idct:single;                                   { IDCT variables }
      Vector:array [0..63] of integer;             { Vector (64 elements) }
          DC:array [1.. 3] of integer;                  { DC coefficients }
      v,w:word;
      r,g,b,m,vv,hh:byte;
      X,Y,Z:longint;
      xx,yy:integer;

Const ZigZag2Table:array [0..7,0..7] of byte=(( 0, 1, 5, 6,14,15,27,28),
                                              ( 2, 4, 7,13,16,26,29,42),
                                              ( 3, 8,12,17,25,30,41,43),
                                              ( 9,11,18,24,31,40,44,53),
                                              (10,19,23,32,39,45,52,54),
                                              (20,22,33,38,46,51,55,60),
                                              (21,34,37,47,50,56,59,61),
                                              (35,36,48,49,57,58,62,63));
    Xres:word=0;     { Video mode constants }
    Yres:word=0;         { (may be changed) }
    BytesPerPixel:byte=0;
    BankSize :longint =0;

function ReadByte:byte;
begin
  BlockRead(PictureFile,Current_byte,1);
              ReadByte:=Current_byte;
  inc(FilePtr);         Current_bit:=0
end;

function ReadWord:word;
 var Current_word:word;
begin
  BlockRead(PictureFile,Current_word,2);
         ReadWord:=Swap(Current_word);
  inc(FilePtr,2)
end;

function Read1bit:byte; { Take one bit from Current Byte }
begin
  if Current_bit=0 then begin ReadByte;
  if Current_byte=$FF then begin Repeat ReadByte Until Current_byte<$FF;
      if (Current_byte>=$D0) and
         (Current_byte<=$D7) then FillChar(DC,SizeOf(DC),0);
  if Current_byte=0 then Current_byte:=$FF else ReadByte
  end end;
  Read1bit:=(Current_byte shr (7-Current_bit)) and 1;
  inc(Current_bit); if Current_bit=8 then Current_bit:=0
end;

procedure NextBit(var V:longint); begin V:=(V shl 1)+Read1bit end;

function ReadBits(bits:byte):word; { Take few bits }
var i:byte; L:longint;
begin
  L:=0; For i:=1 to bits do NextBit(L); ReadBits:=L
end;

function Hi4(b8:byte):byte; begin Hi4:=b8 shr 4  end;

function Lo4(b8:byte):byte; begin Lo4:=b8 and $F end;

function Bits2Integer(bits:byte; value:word):integer;
begin
  if (value and (1 shl (bits-1))>0) then Bits2Integer:=  value
                                    else Bits2Integer:=-(value xor (1 shl bits-1))
end;

function HuffmanCode(T,C:byte):word; { Find Huffman Code from bitstream }
var i,L:byte; V:longint;
begin
  L:=0; V:=0; Repeat inc(L); NextBit(V);
              For i:=0 to $FF do if (Huff_Tab.C[T,C,i].L=L) and
                                    (Huff_Tab.C[T,C,i].V=V) then
                    begin HuffmanCode:=i; Exit end;
              Until L=16; HuffmanCode:=V
end;

procedure YCbCr2RGB(Y,Cb,Cr:integer; var R,G,B:byte); { YCbCr -> RGB }
var RR,GG,BB:integer;                             { color conversion }
begin
  RR:=Round(Y                 +1.40200*(Cr-128));
  GG:=Round(Y-0.34414*(Cb-128)-0.71414*(Cr-128));
  BB:=Round(Y+1.77200*(Cb-128));
  if RR<0 then R:=0 else if RR>255 then R:=255 else R:=RR;
  if GG<0 then G:=0 else if GG>255 then G:=255 else G:=GG;
  if BB<0 then B:=0 else if BB>255 then B:=255 else B:=BB
end;

procedure SetBank(bank:word); assembler;
asm
  mov ax,4F05h { Set active video bank }
  mov bx,0
  mov dx,Bank
  int 10h
end;

procedure pointRGB(x,y:word; r,g,b:byte); { Set color (True Color only) }
var a:longint;
begin
  a:=(longint(y)*Xres+x)*BytesPerPixel;
  SetBank(a div BankSize); mem[$A000:a mod BankSize]:=b; inc(a);
  SetBank(a div BankSize); mem[$A000:a mod BankSize]:=g; inc(a);
  SetBank(a div BankSize); mem[$A000:a mod BankSize]:=r
end;

procedure pixelRGB(x,y:word; var r,g,b:byte);  { Get color (True Color) }
var a:longint; w:word;
begin
  a:=(longint(y)*Xres+x)*BytesPerPixel;
  SetBank(a div BankSize); b:=mem[$A000:a mod BankSize]; inc(a);
  SetBank(a div BankSize); g:=mem[$A000:a mod BankSize]; inc(a);
  SetBank(a div BankSize); r:=mem[$A000:a mod BankSize]
end;

function KeyPressed:boolean; { Return TRUE if any key pressed }
   begin KeyPressed:=(MemW[0:1050]<>MemW[0:1052]) end;


Begin (*********************************************** MAIN PROGRAM ********)

  if ParamCount<1 then begin Write('Please enter JPEG file name : ');
                             ReadLn(FileName) end else FileName:=ParamStr(1);
  if FileName='' then Halt;
  if Pos('.',FileName)=0 then FileName:=FileName+'.JPG';
  Assign(PictureFile,FileName); Reset(PictureFile,1);
  if IOResult<>0 then begin WriteLn('File "',FileName,'" not found'); Halt end;
    Fillchar(Huff_Tab,SizeOf(Huff_Tab),0);
  For m:=$C0 to $FE do Marker[m]:=False;
    method:=0;
    RestartInterval:=0;

  Repeat
    BlockRead(PictureFile,v,2);
    if Lo(v)<>$FF then begin WriteLn('Invalid file format');
                             Close(PictureFile); Halt end;
    b:=Hi(v); Marker[b]:=True;
    Z:=FilePos(PictureFile);
    if (b<>$D8) and (b<>$D9) then begin
      BlockRead(PictureFile,v,2); v:=Swap(v);
      Case b of
  $C0,$C1,$C2,$C3,$C5,$C6,$C7,$C9,$CA,$CB,$CD,$CE,
  $CF: begin
          vv  :=ReadByte;                     { Main Image Parameters }
        Height:=ReadWord;
        Width :=ReadWord;
        planes:=ReadByte;
        if (vv<>8) or ((planes<>1) and (planes<>3)) then begin
                   WriteLn('Only 8-bit Grayscale or RGB images supported');
                   Close(PictureFile); Halt end;
        For hh:=1 to planes do begin
          ComponentID[hh].C:=ReadByte; vv:=ReadByte;
          ComponentID[hh].H:= Hi4(vv);
          ComponentID[hh].V:= Lo4(vv);
          ComponentID[hh].T:=ReadByte
        end;
        method:=b end;
  $C4: begin FilePtr:=0;
        Repeat                        { Read & compile Huffman Tables }
          hh:=ReadByte;
          For vv:=1 to 16 do Huff_Tab.L[vv]:=ReadByte;
          For vv:=1 to 16 do
          For m :=1 to       Huff_Tab.L[vv] do Huff_Tab.V[vv,m]:=ReadByte;
          w:=0;
          For vv:=1 to 16 do begin
          For m :=1 to Huff_Tab.L[vv] do begin
            Huff_Tab.C[Hi4(hh),Lo4(hh),Huff_Tab.V[vv,m]].L:=vv;
            Huff_Tab.C[Hi4(hh),Lo4(hh),Huff_Tab.V[vv,m]].V:=w; inc(w) end;
                                                           w:=w shl 1 end
        Until FilePtr>=v-2
       end;
  $CC: begin FilePtr:=0;
        Repeat                  { Arithmetic Coding Tables (not used) }
          hh:=ReadByte;
          ACT[Hi4(hh),Lo4(hh)]:=ReadByte
        Until FilePtr>=v-2
       end;
  $DA: begin
        m:=ReadByte;                                  { START OF SCAN }
        For hh:=1 to m do begin
        Scan.Component[hh]:=ReadByte; vv:=ReadByte; Scan.TD[hh]:=Hi4(vv);
                                                    Scan.TA[hh]:=Lo4(vv) end;
        Scan.Ss:=ReadByte;
        Scan.Se:=ReadByte; vv:=ReadByte; Scan.Ah:=Hi4(vv);
                                         Scan.Al:=Lo4(vv)
       end;
  $DB: begin FilePtr:=0;
        Repeat                           { Define Quantization Tables }
          hh:=ReadByte;
          For vv:=0 to $3F do
           if Hi4(hh)=0 then ZigZag[Lo(hh),vv]:=ReadByte else
                             ZigZag[Lo(hh),vv]:=ReadWord
        Until FilePtr>=v-2
       end;
  $DD: begin RestartInterval:=ReadWord end
      End;
      Seek(PictureFile,Z+v);
      if IOResult<>0 then begin WriteLn('I/O error !');
                                Close(PictureFile); Halt end
    end
  Until (b=$D9) or (b=$DA);
  if (method<>$C0) or (b=$D9) then begin WriteLn('Not Baseline JPEG');
                                         Close(PictureFile); Halt end;
Z:=0; xx:=Seg(Z); yy:=Ofs(Z);
asm
  mov ax,4F00h { Check VESA sign }
  mov es,xx
  mov di,yy
  int 10h
end;
if Z<>$41534556 then begin WriteLn('VESA not supported'); { Z <> 'VESA' }
                           Close(PictureFile); Halt end;
  w   :=$112;
  Xres:= 640;
  Yres:= 480;
  BytesPerPixel:=4;
  BankSize :=65536;
  v:=0;
asm
  mov ax,4F02h { Set VESA video mode }
  mov bx,w
  int 10h
  cmp ah,0
  jnz @Q
  mov bx,w
  mov v,bx
@Q:
end;
  if v<>w then begin asm
                       mov ax,3 { Text mode }
                       int 10h
                     end; WriteLn('640x480 32bits Video mode not supported');
                          Close(PictureFile); Halt end;

  Case method of
$C0: begin                                              { Baseline method }
      if not (Marker[$C4] and Marker[$DB]) then begin
         WriteLn('Tables markers not found'); Close(PictureFile); Halt end;
      FillChar(DC,SizeOf(DC),0);
    Y:=0; Repeat
    X:=0; Repeat
    For b:=1 to planes do
    For vv:=1 to ComponentID[b].V do
    For hh:=1 to ComponentID[b].H do Begin
      Z:=HuffmanCode(0,Scan.TD[b]);
      Vector[0]:=DC[b]+Bits2Integer(Lo4(Z),ReadBits(Lo4(Z)));
      DC[b]:=Vector[0];
      xx:=1;
      Repeat
        Z:=HuffmanCode(1,Scan.TA[b]);
        if Z=0 then Repeat Vector[xx]:=0; inc(xx) Until xx>=64
               else begin yy:=xx+Hi4(Z);
        While xx<yy do begin Vector[xx]:=0; inc(xx) end;
                       Vector[xx]:=Bits2Integer(Lo4(Z),ReadBits(Lo4(Z)));
                       inc(xx) end
      Until xx>=64;
      For yy:=0 to 7 do
      For xx:=0 to 7 do begin
        sum:=0;
        For v:=0 to 7 do
        For w:=0 to 7 do begin
          m:=ZigZag2Table[v,w];
          idct:=Vector[m]*ZigZag[ComponentID[b].T,m]*Cos((2*xx+1)*w*Pi/16)
                                                    *Cos((2*yy+1)*v*Pi/16);
          if w=0 then idct:=idct/sqrt(2);
          if v=0 then idct:=idct/sqrt(2); sum:=sum+idct
        end;
        w:=X+(hh-1)*8+xx;
        v:=Y+(vv-1)*8+yy;
        if (w<Width) and (v<Height) then begin
           Z:=Round(sum/4)+128; if Z<0 then Z:=0;
                                if Z>255 then Z:=255;
           if b=1 then pointRGB(w,v,Z,Z,Z)
                  else begin pixelRGB(w,v,r,g,m);
                             if b=2 then pointRGB(w,v,r,Z,Z)
                                    else pointRGB(w,v,r,g,Z) end
        end
      end
    End;
    if planes>1 then
    For yy:=ComponentID[1].V*8-1 downto 0 do
    For xx:=ComponentID[1].H*8-1 downto 0 do if (X+xx<Width) and (Y+yy<Height)
    then begin
      pixelRGB(X+xx,Y+yy,r,g,b); { Get YCbCr information }
      Z:=r;
      pixelRGB(X+(xx*ComponentID[2].H) div ComponentID[1].H,
               Y+(yy*ComponentID[2].V) div ComponentID[1].V,r,g,b);
      v:=g;
      pixelRGB(X+(xx*ComponentID[3].H) div ComponentID[1].H,
               Y+(yy*ComponentID[3].V) div ComponentID[1].V,r,g,b);
      w:=b;
      YCbCr2RGB(Z,v,w,r,g,b); pointRGB(X+xx,Y+yy,r,g,b)
    end;
    if KeyPressed then begin asm
                               mov ax,3 { Text mode }
                               int 10h
                             end; WriteLn('Abnormal program termination !');
                                  Close(PictureFile); Halt end;
    Inc(X,ComponentID[1].H*8) Until X>=Width;
      if RestartInterval>0 then Current_bit:=0;
    Inc(Y,ComponentID[1].V*8) Until Y>=Height
     end;
                                { Other compression methods }
  End;
  Close(PictureFile);
  Repeat Until KeyPressed;
asm
  mov ax,3 { Set standard text mode }
  int 10h
end;

End.


